## ags-v.3.5.1.18.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13..3.14)

set(CMAKE_USER_MAKE_RULES_OVERRIDE ${CMAKE_CURRENT_SOURCE_DIR}/CMake/c_flag_overrides.cmake)
set(CMAKE_USER_MAKE_RULES_OVERRIDE_CXX ${CMAKE_CURRENT_SOURCE_DIR}/CMake/cxx_flag_overrides.cmake)
set(CMAKE_OSX_DEPLOYMENT_TARGET "10.9" CACHE STRING "Minimum OS X deployment version")

project(AGS
    VERSION 3.5.1.18
    LANGUAGES CXX C)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/CMake")

option(AGS_NO_MP3_PLAYER "Disable MP3" OFF)
option(AGS_NO_VIDEO_PLAYER "Disable Video" OFF)
option(AGS_BUILTIN_PLUGINS "Built in plugins" OFF)
set(AGS_BUILD_STR "" CACHE STRING "Engine Build Information")

include(FetchContent)
set(FETCHCONTENT_UPDATES_DISCONNECTED on)

if (${CMAKE_SYSTEM_NAME} MATCHES "Windows")
    # WIN32 is set by CMake for any Windows platform
elseif (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    set(LINUX TRUE)
elseif (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set(MACOS TRUE)
else()
    message(FATAL_ERROR "Unsupported system: ${CMAKE_SYSTEM_NAME}")
endif ()

if (WIN32 AND NOT CMAKE_SIZEOF_VOID_P EQUAL 4)
	message(FATAL_ERROR "Windows builds only support 32bit for now")
endif()


include(CheckIPOSupported)
check_ipo_supported(RESULT ipo_supported OUTPUT ipo_not_supported_reason)
if(ipo_supported)
    set(CMAKE_INTERPROCEDURAL_OPTIMIZATION_RELEASE          TRUE)
    set(CMAKE_INTERPROCEDURAL_OPTIMIZATION_RELWITHDEBINFO   TRUE)
else()
    message(STATUS "Interprocedural optimisation (IPO/LTO) not supported: <${ipo_not_supported_reason}>")
endif()


add_compile_definitions("_FILE_OFFSET_BITS=64")

add_compile_definitions("$<$<CONFIG:DEBUG>:_DEBUG>")
add_compile_definitions("$<$<CONFIG:RELEASE>:NDEBUG>")

if(MSVC)
    add_compile_options(/MP)    # Build with Multiple Processes
    add_compile_definitions(_CRT_SECURE_NO_DEPRECATE)
    add_compile_definitions(_CRT_NONSTDC_NO_DEPRECATE)
else()
    add_compile_options(
        -fsigned-char 
        -fno-strict-aliasing 
        -fwrapv

        -Wall
        -Wextra

        -Wendif-labels
        -Wfloat-equal
        -Wformat
        -Wformat-security
        -Winit-self
        -Winline
        -Wmissing-noreturn
        -Wpointer-arith
        -Wshadow
        -Wundef
        -Wwrite-strings
        -Wunused-result

        # probably need fixing but disable until we have time
        -Wno-unknown-pragmas
        -Wno-deprecated-declarations
        -Wno-unused-parameter
        -Wno-sign-compare
        -Wno-cast-align
        -Wno-cast-qual
        -Wno-missing-declarations
        -Wno-switch-enum
        # -Wlarger-than-4096
        -Wno-redundant-decls

        -Werror=write-strings
        #-Werror=implicit-function-declaration
        #-Werror=unused-result
    )

    add_compile_options($<$<COMPILE_LANGUAGE:CXX>:-Wno-old-style-cast>)
    add_compile_options($<$<COMPILE_LANGUAGE:CXX>:-Werror=delete-non-virtual-dtor>)

    add_compile_options($<$<COMPILE_LANGUAGE:C>:-Wbad-function-cast>)
    add_compile_options($<$<COMPILE_LANGUAGE:C>:-Wdeclaration-after-statement>)
    add_compile_options($<$<COMPILE_LANGUAGE:C>:-Wno-missing-prototypes>)
    add_compile_options($<$<COMPILE_LANGUAGE:C>:-Wold-style-definition>)
    add_compile_options($<$<COMPILE_LANGUAGE:C>:-Wstrict-prototypes>)

endif()

find_package(PkgConfig)
find_package(Threads)

if (WIN32)
    find_package(DirectX)
elseif (LINUX)
    find_package(X11)
endif()

include(FetchAllegro)
include(FetchOgg)
include(FetchVorbis)
include(FetchTheora)

add_subdirectory(Common/libsrc/aastr-0.1.1      EXCLUDE_FROM_ALL)
add_subdirectory(Common/libsrc/alfont-2.0.9     EXCLUDE_FROM_ALL)
add_subdirectory(Common/libsrc/freetype-2.1.3   EXCLUDE_FROM_ALL)
add_subdirectory(Common                         EXCLUDE_FROM_ALL)

add_subdirectory(Engine/libsrc/almp3-2.0.5      EXCLUDE_FROM_ALL)
add_subdirectory(Engine/libsrc/alogg            EXCLUDE_FROM_ALL)
add_subdirectory(Engine/libsrc/apeg-1.2.1       EXCLUDE_FROM_ALL)
add_subdirectory(Engine/libsrc/dumb-0.9.2       EXCLUDE_FROM_ALL)
add_subdirectory(Engine/libsrc/glad             EXCLUDE_FROM_ALL)
add_subdirectory(Engine/libsrc/hq2x             EXCLUDE_FROM_ALL)
add_subdirectory(Engine/libsrc/libcda-0.5       EXCLUDE_FROM_ALL)

add_subdirectory(Engine)

set_property(DIRECTORY ${PROJECT_SOURCE_DIR} PROPERTY VS_STARTUP_PROJECT ags)

=== Common/CMakeLists.txt ===
include(TestBigEndian)
include(CheckFseeko)

add_library(common)

set_target_properties(common PROPERTIES
    CXX_STANDARD 11
    CXX_EXTENSIONS NO
)

target_include_directories(common PUBLIC .)

target_sources(common 
    PRIVATE
    ac/audiocliptype.cpp
    ac/audiocliptype.h
    ac/characterinfo.cpp
    ac/characterinfo.h
    ac/common.cpp
    ac/common.h
    ac/common_defines.h
    ac/dialogtopic.cpp
    ac/dialogtopic.h
    ac/dynobj/scriptaudioclip.cpp
    ac/dynobj/scriptaudioclip.h
    ac/game_version.h
    ac/gamesetupstruct.cpp
    ac/gamesetupstruct.h
    ac/gamesetupstructbase.cpp
    ac/gamesetupstructbase.h
    ac/gamestructdefines.h
    ac/interfacebutton.h
    ac/interfaceelement.h
    ac/inventoryiteminfo.cpp
    ac/inventoryiteminfo.h
    ac/mousecursor.cpp
    ac/mousecursor.h
    ac/oldgamesetupstruct.h
    ac/spritecache.cpp
    ac/spritecache.h
    ac/view.cpp
    ac/view.h
    ac/wordsdictionary.cpp
    ac/wordsdictionary.h
    api/stream_api.h
    core/asset.cpp
    core/asset.h
    core/assetmanager.cpp
    core/assetmanager.h
    core/def_version.h
    core/types.h
    debug/assert.h
    debug/debugmanager.cpp
    debug/debugmanager.h
    debug/out.h
    debug/outputhandler.h
    font/agsfontrenderer.h
    font/fonts.cpp
    font/fonts.h
    font/ttffontrenderer.cpp
    font/ttffontrenderer.h
    font/wfnfont.cpp
    font/wfnfont.h
    font/wfnfontrenderer.cpp
    font/wfnfontrenderer.h
    game/customproperties.cpp
    game/customproperties.h
    game/interactions.cpp
    game/interactions.h
    game/main_game_file.cpp
    game/main_game_file.h
    game/plugininfo.h
    game/room_file.cpp
    game/room_file.h
    game/room_file_deprecated.cpp
    game/room_version.h
    game/roomstruct.cpp
    game/roomstruct.h
    gfx/allegrobitmap.cpp
    gfx/allegrobitmap.h
    gfx/bitmap.cpp
    gfx/bitmap.h
    gfx/gfx_def.h
    gui/guibutton.cpp
    gui/guibutton.h
    gui/guidefines.h
    gui/guiinv.cpp
    gui/guiinv.h
    gui/guilabel.cpp
    gui/guilabel.h
    gui/guilistbox.cpp
    gui/guilistbox.h
    gui/guimain.cpp
    gui/guimain.h
    gui/guiobject.cpp
    gui/guiobject.h
    gui/guislider.cpp
    gui/guislider.h
    gui/guitextbox.cpp
    gui/guitextbox.h
    script/cc_error.cpp
    script/cc_error.h
    script/cc_options.cpp
    script/cc_options.h
    script/cc_script.cpp
    script/cc_script.h
    script/script_common.h
    util/alignedstream.cpp
    util/alignedstream.h
    util/bbop.h
    util/compress.cpp
    util/compress.h
    util/datastream.cpp
    util/datastream.h
    util/directory.cpp
    util/directory.h
    util/error.h
    util/file.cpp
    util/file.h
    util/filestream.cpp
    util/filestream.h
    util/geometry.cpp
    util/geometry.h
    util/ini_util.cpp
    util/ini_util.h
    util/inifile.cpp
    util/inifile.h
    util/lzw.cpp
    util/lzw.h
    util/math.h
    util/memory.h
    util/misc.cpp
    util/misc.h
    util/multifilelib.h
    util/mutifilelib.cpp
    util/path.cpp
    util/path.h
    util/proxystream.cpp
    util/proxystream.h
    util/stdio_compat.c
    util/stdio_compat.h
    util/stream.cpp
    util/stream.h
    util/string.cpp
    util/string.h
    util/string_types.h
    util/string_utils.cpp
    util/string_utils.h
    util/textreader.h
    util/textstreamreader.cpp
    util/textstreamreader.h
    util/textstreamwriter.cpp
    util/textstreamwriter.h
    util/textwriter.h
    util/version.cpp
    util/version.h
    util/wgt2allg.cpp
    util/wgt2allg.h
    util/bufferedstream.cpp
    util/bufferedstream.h
    util/string_compat.c
    util/string_compat.h
)

target_link_libraries(common PUBLIC Allegro::Allegro AlFont::AlFont AAStr::AAStr)

# NOTE: You can optionally create case sensitive filesystems on Macos and Windows now.
if (LINUX)
    target_compile_definitions(common PRIVATE AGS_CASE_SENSITIVE_FILESYSTEM)
endif()

if (HAVE_FSEEKO)
    target_compile_definitions(common PUBLIC HAVE_FSEEKO)
endif()

if (AGS_NO_MP3_PLAYER)
    target_compile_definitions(common PUBLIC NO_MP3_PLAYER)
endif()

if(NOT MSVC)
    target_compile_options(common PUBLIC -Werror=undef)
endif()

target_compile_definitions(common PUBLIC "$<$<CONFIG:DEBUG>:DEBUG_SPRITECACHE>")

get_target_property(COMMON_SOURCES common SOURCES)
source_group(TREE ${CMAKE_CURRENT_SOURCE_DIR} PREFIX "Source Files" FILES ${COMMON_SOURCES})

add_library(AGS::Common ALIAS common)

=== Engine/CMakeLists.txt ===
# Engine
# -----------------------------------------------------------------------------

add_library(engine)

set_target_properties(engine PROPERTIES
    CXX_STANDARD 11
    CXX_EXTENSIONS NO
)

target_include_directories(engine PUBLIC .)

target_sources(engine
    PRIVATE
    ac/asset_helper.h
    ac/audiochannel.cpp
    ac/audiochannel.h
    ac/audioclip.cpp
    ac/audioclip.h
    ac/button.cpp
    ac/button.h
    ac/cdaudio.cpp
    ac/cdaudio.h
    ac/character.cpp
    ac/character.h
    ac/charactercache.h
    ac/characterextras.cpp
    ac/characterextras.h
    ac/characterinfo_engine.cpp
    ac/datetime.cpp
    ac/datetime.h
    ac/dialog.cpp
    ac/dialog.h
    ac/dialogoptionsrendering.cpp
    ac/dialogoptionsrendering.h
    ac/display.cpp
    ac/display.h
    ac/draw.cpp
    ac/draw.h
    ac/draw_software.cpp
    ac/draw_software.h
    ac/drawingsurface.cpp
    ac/drawingsurface.h
    ac/dynamicsprite.cpp
    ac/dynamicsprite.h
    ac/dynobj/all_dynamicclasses.h
    ac/dynobj/all_scriptclasses.h
    ac/dynobj/cc_agsdynamicobject.cpp
    ac/dynobj/cc_agsdynamicobject.h
    ac/dynobj/cc_audiochannel.cpp
    ac/dynobj/cc_audiochannel.h
    ac/dynobj/cc_audioclip.cpp
    ac/dynobj/cc_audioclip.h
    ac/dynobj/cc_character.cpp
    ac/dynobj/cc_character.h
    ac/dynobj/cc_dialog.cpp
    ac/dynobj/cc_dialog.h
    ac/dynobj/cc_dynamicarray.cpp
    ac/dynobj/cc_dynamicarray.h
    ac/dynobj/cc_dynamicobject.cpp
    ac/dynobj/cc_dynamicobject.h
    ac/dynobj/cc_gui.cpp
    ac/dynobj/cc_gui.h
    ac/dynobj/cc_guiobject.cpp
    ac/dynobj/cc_guiobject.h
    ac/dynobj/cc_hotspot.cpp
    ac/dynobj/cc_hotspot.h
    ac/dynobj/cc_inventory.cpp
    ac/dynobj/cc_inventory.h
    ac/dynobj/cc_object.cpp
    ac/dynobj/cc_object.h
    ac/dynobj/cc_region.cpp
    ac/dynobj/cc_region.h
    ac/dynobj/cc_serializer.cpp
    ac/dynobj/cc_serializer.h
    ac/dynobj/managedobjectpool.cpp
    ac/dynobj/managedobjectpool.h
    ac/dynobj/scriptaudiochannel.h
    ac/dynobj/scriptcamera.cpp
    ac/dynobj/scriptcamera.h
    ac/dynobj/scriptdatetime.cpp
    ac/dynobj/scriptdatetime.h
    ac/dynobj/scriptdialog.h
    ac/dynobj/scriptdialogoptionsrendering.cpp
    ac/dynobj/scriptdialogoptionsrendering.h
    ac/dynobj/scriptdrawingsurface.cpp
    ac/dynobj/scriptdrawingsurface.h
    ac/dynobj/scriptdynamicsprite.cpp
    ac/dynobj/scriptdynamicsprite.h
    ac/dynobj/scriptfile.cpp
    ac/dynobj/scriptfile.h
    ac/dynobj/scriptgui.h
    ac/dynobj/scripthotspot.h
    ac/dynobj/scriptinvitem.h
    ac/dynobj/scriptmouse.h
    ac/dynobj/scriptobject.h
    ac/dynobj/scriptoverlay.cpp
    ac/dynobj/scriptoverlay.h
    ac/dynobj/scriptregion.h
    ac/dynobj/scriptstring.cpp
    ac/dynobj/scriptstring.h
    ac/dynobj/scriptsystem.h
    ac/dynobj/scriptuserobject.cpp
    ac/dynobj/scriptuserobject.h
    ac/dynobj/scriptviewframe.cpp
    ac/dynobj/scriptviewframe.h
    ac/dynobj/scriptviewport.cpp
    ac/dynobj/scriptviewport.h
    ac/event.cpp
    ac/event.h
    ac/file.cpp
    ac/file.h
    ac/game.cpp
    ac/game.h
    ac/gamesetup.cpp
    ac/gamesetup.h
    ac/gamestate.cpp
    ac/gamestate.h
    ac/global_api.cpp
    ac/global_audio.cpp
    ac/global_audio.h
    ac/global_button.cpp
    ac/global_button.h
    ac/global_character.cpp
    ac/global_character.h
    ac/global_datetime.cpp
    ac/global_datetime.h
    ac/global_debug.cpp
    ac/global_debug.h
    ac/global_dialog.cpp
    ac/global_dialog.h
    ac/global_display.cpp
    ac/global_display.h
    ac/global_drawingsurface.cpp
    ac/global_drawingsurface.h
    ac/global_dynamicsprite.cpp
    ac/global_dynamicsprite.h
    ac/global_file.cpp
    ac/global_file.h
    ac/global_game.cpp
    ac/global_game.h
    ac/global_gui.cpp
    ac/global_gui.h
    ac/global_hotspot.cpp
    ac/global_hotspot.h
    ac/global_inventoryitem.cpp
    ac/global_inventoryitem.h
    ac/global_invwindow.cpp
    ac/global_invwindow.h
    ac/global_label.cpp
    ac/global_label.h
    ac/global_listbox.cpp
    ac/global_listbox.h
    ac/global_mouse.cpp
    ac/global_mouse.h
    ac/global_object.cpp
    ac/global_object.h
    ac/global_overlay.cpp
    ac/global_overlay.h
    ac/global_palette.cpp
    ac/global_palette.h
    ac/global_parser.cpp
    ac/global_parser.h
    ac/global_plugin.h
    ac/global_record.cpp
    ac/global_record.h
    ac/global_region.cpp
    ac/global_region.h
    ac/global_room.cpp
    ac/global_room.h
    ac/global_screen.cpp
    ac/global_screen.h
    ac/global_slider.cpp
    ac/global_slider.h
    ac/global_string.cpp
    ac/global_string.h
    ac/global_textbox.cpp
    ac/global_textbox.h
    ac/global_timer.cpp
    ac/global_timer.h
    ac/global_translation.cpp
    ac/global_translation.h
    ac/global_video.cpp
    ac/global_video.h
    ac/global_viewframe.cpp
    ac/global_viewframe.h
    ac/global_viewport.cpp
    ac/global_viewport.h
    ac/global_walkablearea.cpp
    ac/global_walkablearea.h
    ac/global_walkbehind.cpp
    ac/global_walkbehind.h
    ac/gui.cpp
    ac/gui.h
    ac/guicontrol.cpp
    ac/guicontrol.h
    ac/guiinv.cpp
    ac/hotspot.cpp
    ac/hotspot.h
    ac/interfacebutton.cpp
    ac/interfaceelement.cpp
    ac/inventoryitem.cpp
    ac/inventoryitem.h
    ac/invwindow.cpp
    ac/invwindow.h
    ac/keycode.cpp
    ac/keycode.h
    ac/label.cpp
    ac/label.h
    ac/lipsync.h
    ac/listbox.cpp
    ac/listbox.h
    ac/math.cpp
    ac/math.h
    ac/mouse.cpp
    ac/mouse.h
    ac/movelist.cpp
    ac/movelist.h
    ac/object.cpp
    ac/object.h
    ac/objectcache.h
    ac/overlay.cpp
    ac/overlay.h
    ac/parser.cpp
    ac/parser.h
    ac/path_helper.h
    ac/properties.cpp
    ac/properties.h
    ac/region.cpp
    ac/region.h
    ac/richgamemedia.cpp
    ac/richgamemedia.h
    ac/room.cpp
    ac/room.h
    ac/roomobject.cpp
    ac/roomobject.h
    ac/roomstatus.cpp
    ac/roomstatus.h
    ac/route_finder.cpp
    ac/route_finder.h
    ac/route_finder_impl.cpp
    ac/route_finder_impl.h
    ac/route_finder_impl_legacy.cpp
    ac/route_finder_impl_legacy.h
    ac/runtime_defines.h
    ac/screen.cpp
    ac/screen.h
    ac/screenoverlay.cpp
    ac/screenoverlay.h
    ac/slider.cpp
    ac/slider.h
    ac/speech.cpp
    ac/speech.h
    ac/sprite.cpp
    ac/sprite.h
    ac/spritecache_engine.cpp
    ac/spritelistentry.h
    ac/statobj/agsstaticobject.cpp
    ac/statobj/agsstaticobject.h
    ac/statobj/staticarray.cpp
    ac/statobj/staticarray.h
    ac/statobj/staticobject.h
    ac/string.cpp
    ac/string.h
    ac/sys_events.cpp
    ac/sys_events.h
    ac/system.cpp
    ac/system.h
    ac/textbox.cpp
    ac/textbox.h
    ac/timer.cpp
    ac/timer.h
    ac/topbarsettings.h
    ac/translation.cpp
    ac/translation.h
    ac/tree_map.cpp
    ac/tree_map.h
    ac/viewframe.cpp
    ac/viewframe.h
    ac/viewport_script.cpp
    ac/walkablearea.cpp
    ac/walkablearea.h
    ac/walkbehind.cpp
    ac/walkbehind.h
    debug/agseditordebugger.h
    debug/consoleoutputtarget.cpp
    debug/consoleoutputtarget.h
    debug/debug.cpp
    debug/debug_log.h
    debug/debugger.h
    debug/dummyagsdebugger.h
    debug/filebasedagsdebugger.cpp
    debug/filebasedagsdebugger.h
    debug/logfile.cpp
    debug/logfile.h
    debug/messagebuffer.cpp
    debug/messagebuffer.h
    device/mousew32.cpp
    device/mousew32.h
    font/fonts_engine.cpp
    game/game_init.cpp
    game/game_init.h
    game/savegame.cpp
    game/savegame.h
    game/savegame_components.cpp
    game/savegame_components.h
    game/savegame_internal.h
    game/savegame_v321.cpp
    game/viewport.cpp
    game/viewport.h
    gfx/ali3dexception.h
    gfx/ali3dogl.cpp
    gfx/ali3dogl.h
    gfx/ali3dsw.cpp
    gfx/ali3dsw.h
    gfx/blender.cpp
    gfx/blender.h
    gfx/color_engine.cpp
    gfx/ddb.h
    gfx/gfx_util.cpp
    gfx/gfx_util.h
    gfx/gfxdefines.h
    gfx/gfxdriverbase.cpp
    gfx/gfxdriverbase.h
    gfx/gfxdriverfactory.cpp
    gfx/gfxdriverfactory.h
    gfx/gfxdriverfactorybase.h
    gfx/gfxfilter.h
    gfx/gfxfilter_aad3d.cpp
    gfx/gfxfilter_aad3d.h
    gfx/gfxfilter_aaogl.cpp
    gfx/gfxfilter_aaogl.h
    gfx/gfxfilter_allegro.cpp
    gfx/gfxfilter_allegro.h
    gfx/gfxfilter_d3d.cpp
    gfx/gfxfilter_d3d.h
    gfx/gfxfilter_hqx.cpp
    gfx/gfxfilter_hqx.h
    gfx/gfxfilter_ogl.cpp
    gfx/gfxfilter_ogl.h
    gfx/gfxfilter_scaling.cpp
    gfx/gfxfilter_scaling.h
    gfx/gfxmodelist.h
    gfx/graphicsdriver.h
    gfx/ogl_headers.h
    gui/animatingguibutton.cpp
    gui/animatingguibutton.h
    gui/cscidialog.cpp
    gui/cscidialog.h
    gui/gui_engine.cpp
    gui/guidialog.cpp
    gui/guidialog.h
    gui/guidialogdefines.h
    gui/guidialoginternaldefs.h
    gui/mycontrols.h
    gui/mylabel.cpp
    gui/mylabel.h
    gui/mylistbox.cpp
    gui/mylistbox.h
    gui/mypushbutton.cpp
    gui/mypushbutton.h
    gui/mytextbox.cpp
    gui/mytextbox.h
    gui/newcontrol.cpp
    gui/newcontrol.h
    main/config.cpp
    main/config.h
    main/engine.cpp
    main/engine.h
    main/engine_setup.cpp
    main/engine_setup.h
    main/game_file.cpp
    main/game_file.h
    main/game_run.cpp
    main/game_run.h
    main/game_start.cpp
    main/game_start.h
    main/graphics_mode.cpp
    main/graphics_mode.h
    main/main.cpp
    main/main.h
    main/main_allegro.h
    main/maindefines_ex.h
    main/mainheader.h
    main/quit.cpp
    main/quit.h
    main/update.cpp
    main/update.h
    media/audio/ambientsound.cpp
    media/audio/ambientsound.h
    media/audio/audio.cpp
    media/audio/audio.h
    media/audio/audio_system.h
    media/audio/audiodefines.h
    media/audio/audiointernaldefs.h
    media/audio/clip_mydumbmod.cpp
    media/audio/clip_mydumbmod.h
    media/audio/clip_myjgmod.cpp
    media/audio/clip_myjgmod.h
    media/audio/clip_mymidi.cpp
    media/audio/clip_mymidi.h
    media/audio/clip_mymp3.cpp
    media/audio/clip_mymp3.h
    media/audio/clip_myogg.cpp
    media/audio/clip_myogg.h
    media/audio/clip_mystaticmp3.cpp
    media/audio/clip_mystaticmp3.h
    media/audio/clip_mystaticogg.cpp
    media/audio/clip_mystaticogg.h
    media/audio/clip_mywave.cpp
    media/audio/clip_mywave.h
    media/audio/queuedaudioitem.cpp
    media/audio/queuedaudioitem.h
    media/audio/sound.cpp
    media/audio/sound.h
    media/audio/soundcache.cpp
    media/audio/soundcache.h
    media/audio/soundclip.cpp
    media/audio/soundclip.h
    media/video/VMR9Graph.h
    media/video/video.cpp
    media/video/video.h
    platform/base/agsplatformdriver.cpp
    platform/base/agsplatformdriver.h
    platform/util/libc.c
    platform/util/pe.c
    platform/util/pe.h
    plugin/agsplugin.cpp
    plugin/agsplugin.h
    plugin/global_plugin.cpp
    plugin/plugin_builtin.h
    plugin/plugin_engine.h
    plugin/pluginobjectreader.cpp
    plugin/pluginobjectreader.h
    resource/resource.h
    script/cc_error_engine.cpp
    script/cc_instance.cpp
    script/cc_instance.h
    script/executingscript.cpp
    script/executingscript.h
    script/exports.cpp
    script/exports.h
    script/nonblockingscriptfunction.h
    script/runtimescriptvalue.cpp
    script/runtimescriptvalue.h
    script/script.cpp
    script/script.h
    script/script_api.cpp
    script/script_api.h
    script/script_engine.cpp
    script/script_runtime.cpp
    script/script_runtime.h
    script/systemimports.cpp
    script/systemimports.h
    test/test_all.cpp
    test/test_all.h
    test/test_file.cpp
    test/test_gfx.cpp
    test/test_inifile.cpp
    test/test_math.cpp
    test/test_memory.cpp
    test/test_sprintf.cpp
    test/test_string.cpp
    test/test_version.cpp
    util/library.h
    util/library_dummy.h
    util/library_posix.h
    util/mutex.h
    util/mutex_base.h
    util/mutex_lock.h
    util/mutex_pthread.h
    util/mutex_std.h
    util/scaling.h
    util/thread.h
    util/thread_pthread.h
    util/thread_std.h
    ac/scriptcontainers.cpp
    ac/dynobj/scriptcontainers.h
    ac/dynobj/scriptdict.cpp
    ac/dynobj/scriptdict.h
    ac/dynobj/scriptset.cpp
    ac/dynobj/scriptset.h

    platform/windows/acplwin.cpp

=== Engine/Makefile ===
UNAME := $(shell uname)

ifeq ($(V), 1)
CMD_PREFIX :=
else
CMD_PREFIX := @
endif

include Makefile-objs

ifeq ($(UNAME), Darwin)
include Makefile-defs.osx
else
include Makefile-defs.linux
endif

ifneq ($(USE_MIDI_PATCH), 1)
AL_MIDI_PATCH :=
endif

OBJS := $(ALMP3) $(ALOGG) $(APEG) $(AASTR) $(HQ2X3X) $(AL_MIDI_PATCH) $(CDA) $(ALDUMB) $(GLAD) $(PLUGINS) $(BASE) $(BASE_PLATFORM)
OBJS := $(OBJS:.mm=.o)
OBJS := $(OBJS:.cpp=.o)
OBJS := $(OBJS:.c=.o)

OBJS_COMMON := $(COMMON) $(ALFONT) $(FREETYPE)
OBJS_COMMON := $(OBJS_COMMON:.mm=.o)
OBJS_COMMON := $(OBJS_COMMON:.cpp=.o)
OBJS_COMMON := $(OBJS_COMMON:.c=.o)
DEPFILES = $(OBJS:.o=.d) $(OBJS_COMMON:.o=.d)

-include config.mak

.PHONY: printflags clean install uninstall rebuild

all: printflags ags

ags: $(OBJS) common.a 
	@echo "Linking engine..."
	$(CMD_PREFIX) $(CXX) -o $@ $^ $(CXXFLAGS) $(LDFLAGS) $(LIBS)

debug: CXXFLAGS += -UNDEBUG -D_DEBUG -Og -g -pg
debug: CFLAGS   += -UNDEBUG -D_DEBUG -Og -g -pg
debug: MMFLAGS  += -UNDEBUG -D_DEBUG -Og -g -pg
debug: LDFLAGS  += -pg
debug: printflags ags

common.a: $(OBJS_COMMON)
	@echo "Linking common library..."
	$(CMD_PREFIX) $(AR) rcs $@ $^

-include $(DEPFILES)

%.o: %.c
	@echo $@
	$(CMD_PREFIX) $(CC) $(CFLAGS) -MD -c -o $@ $<

%.o: %.mm
	@echo $@
	$(CMD_PREFIX) $(CC) $(MMFLAGS) -MD -c -o $@ $<

%.o: %.cpp
	@echo $@
	$(CMD_PREFIX) $(CXX) $(CXXFLAGS) -MD -c -o $@ $<

printflags:
	@echo "CFLAGS =" $(CFLAGS) "\n"
	@echo "CXXFLAGS =" $(CXXFLAGS) "\n"
	@echo "MMFLAGS =" $(MMFLAGS) "\n"
	@echo "LDFLAGS =" $(LDFLAGS) "\n"
	@echo "LIBS =" $(LIBS) "\n"

rebuild: clean all

clean:
	@echo "Cleaning..."
	$(CMD_PREFIX) rm -f ags common.a $(OBJS) $(OBJS_COMMON) $(DEPFILES)

install: ags
	mkdir -p $(PREFIX)/bin
	cp -t $(PREFIX)/bin ags

uninstall:
	rm -f $(PREFIX)/bin/ags

=== PSP/Makefile ===
DISTRIB_NAME?=AGS_Runtime_for_PSP_3.21_R9
PSP_AGS_FOLDER?=j:/psp/game/ags
COPY?=0

export DISTRIB_NAME
export PSP_AGS_FOLDER
export COPY

DIST_PREFIX=../PSP/dist/$(DISTRIB_NAME)

.PHONY: kernelprx exceptionprx launchereboot engineprx allplugins \
        cleankernelprx cleanexceptionprx cleanlaunchereboot cleanengineprx cleanallplugins \
        distrib

all: kernelprx exceptionprx launchereboot engineprx allplugins

kernelprx:
	@$(MAKE) -C "kernel"
	@cp "kernel/kernel.prx" "bin"
ifeq ($(COPY), 1)
	@cp "kernel/kernel.prx" $(PSP_AGS_FOLDER)
endif

exceptionprx:
	@$(MAKE) -C "exception/prx"
	@cp "exception/prx/exception.prx" "bin"
ifeq ($(COPY), 1)
	@cp "exception/prx/exception.prx" $(PSP_AGS_FOLDER)
endif

launchereboot:
	@$(MAKE) -C "launcher"
	@cp "launcher/EBOOT.PBP" "bin"
ifeq ($(COPY), 1)
	@cp "launcher/EBOOT.PBP" $(PSP_AGS_FOLDER)
endif

engineprx:
	@$(MAKE) -C "../Engine" -f Makefile.psp
	@cp "../Engine/ags321.prx" "bin"
ifeq ($(COPY), 1)
	@cp "../Engine/ags321.prx" $(PSP_AGS_FOLDER)
endif

allplugins:
	@$(MAKE) -C "../Plugins" -f Makefile.psp

cleankernelprx:
	@$(MAKE) -C "kernel" clean
	@rm -f "bin/kernel.prx"

cleanexceptionprx:
	@$(MAKE) -C "exception/prx" clean
	@rm -f "bin/exception.prx"

cleanlaunchereboot:
	@$(MAKE) -C "launcher" clean
	@rm -f "bin/EBOOT.PBP"

cleanengineprx:
	@$(MAKE) C "../Engine" -f Makefile.psp clean
	@rm -f "bin/ags321.prx"

cleanallplugins:
	@$(MAKE) -C "../Plugins" -f Makefile.psp clean

distrib: all
	@mkdir -p "$(DIST_PREFIX)"
	@cp "bin/EBOOT.PBP" "$(DIST_PREFIX)/EBOOT.PBP"
	@cp "bin/ags321.prx" "$(DIST_PREFIX)/ags321.prx"
	@cp "bin/kernel.prx" "$(DIST_PREFIX)/kernel.prx"
	@cp "bin/exception.prx" "$(DIST_PREFIX)/exception.prx"
	@cp "bin/psp.cfg" "$(DIST_PREFIX)/psp.cfg"
	@cp "README.md" "$(DIST_PREFIX)/readme.txt"
	@cp "../License.txt" "$(DIST_PREFIX)/License.txt"
	@cp "../Copyright.txt" "$(DIST_PREFIX)/Copyright.txt"
	@$(MAKE) -C "../Plugins" -f Makefile.psp distrib

clean: cleankernelprx cleanexceptionprx cleanlaunchereboot cleanengineprx cleanallplugins

=== OSX/buildlibs/Makefile ===
#!/bin/bash

LIBSRCDIR:=$(shell pwd)/../../libsrc
PATCHESDIR:=$(shell pwd)/../patches
PREFIX:=$(shell pwd)/opt
BUILD:=$(shell pwd)/build
PKG_CONFIG_PATH:=${PREFIX}/lib/pkgconfig
export PKG_CONFIG_PATH
PLAT_FLAGS:=-mmacosx-version-min=10.7 -arch i386 -arch x86_64
	
.PHONY: libs prepare lua freetype ogg vorbis theora allegro dumb install

libs: lua freetype ogg vorbis theora allegro dumb

install: libs
	rm -rf ../lib
	rm -rf ../include
	mkdir -p ../lib
	cp $(PREFIX)/lib/*.a ../lib
	cp -a $(PREFIX)/include ../include

prepare:
	cd $(LIBSRCDIR) && ./download.sh
	./checkenv.sh
	mkdir -p $(PREFIX)
	mkdir -p $(BUILD)

lua: prepare
	tar xf $(LIBSRCDIR)/lua-5.1.5.tar.gz -C $(BUILD)
	cd $(BUILD)/lua-5.1.5 && \
		patch -p1 < $(PATCHESDIR)/lua-5.1.5.patch && \
		make macosx INSTALL_TOP="$(PREFIX)" PLAT_LDFLAGS="$(PLAT_FLAGS)" PLAT_CFLAGS="$(PLAT_FLAGS)" && \
		make install INSTALL_TOP="$(PREFIX)"

freetype: prepare
	tar xf $(LIBSRCDIR)/freetype-2.4.12.tar.bz2 -C $(BUILD)
	cd $(BUILD)/freetype-2.4.12 && \
		./configure CFLAGS="$(PLAT_FLAGS)" LDFLAGS="$(PLAT_FLAGS)" \
		    --prefix=$(PREFIX) \
		    --enable-static --disable-shared \
		    --enable-biarch-config && \
		make && \
		make install 

ogg: prepare
	tar xf $(LIBSRCDIR)/libogg-1.3.2.tar.gz -C $(BUILD)
	cd $(BUILD)/libogg-1.3.2 && \
		./configure CFLAGS="$(PLAT_FLAGS)" LDFLAGS="$(PLAT_FLAGS)" \
		    --prefix=$(PREFIX) \
		    --enable-static --disable-shared && \
		make && \
		make install 

vorbis: prepare ogg
	tar xf $(LIBSRCDIR)/libvorbis-1.3.5.tar.gz -C $(BUILD)
	cd $(BUILD)/libvorbis-1.3.5 && \
		./configure CFLAGS="$(PLAT_FLAGS)" LDFLAGS="$(PLAT_FLAGS)" \
		    --prefix=$(PREFIX) \
		    --enable-static --disable-shared \
		    --disable-docs --disable-examples --disable-oggtest && \
		make && \
		make install 

theora: prepare ogg vorbis
	tar xf $(LIBSRCDIR)/libtheora-20160525-g50df933.tar.bz2 -C $(BUILD)
	cd $(BUILD)/libtheora-20160525-g50df933 && \
		./autogen.sh CFLAGS="$(PLAT_FLAGS)" LDFLAGS="$(PLAT_FLAGS)"  \
		    --prefix=$(PREFIX) \
		    --enable-static --disable-shared \
		    --with-ogg=$(PREFIX) --with-vorbis=$(PREFIX) \
		    --disable-examples \
		    --disable-asm \
		    --disable-vorbistest \
		    --disable-oggtest \
		    --disable-doc   \
		    --disable-spec  && \
		make && \
		make install

# - you can add `-DCMAKE_BUILD_TYPE=Debug` to the cmake options but remember it will produce the file `liballeg-debug.a`
# - to update patch: git diff 4.4.2..osx-update > ../ags/OSX/patches/allegro-4.4.2.patch
allegro: prepare
	rm -rf $(BUILD)/allegro-4.4.2
	tar xf $(LIBSRCDIR)/allegro-4.4.2.tar.gz -C $(BUILD)
	cd $(BUILD)/allegro-4.4.2 && \
		patch -p1 < $(PATCHESDIR)/allegro-4.4.2.patch && \
		mkdir -p build && \
		pushd build && \
		cmake \
		'-DCMAKE_OSX_ARCHITECTURES=x86_64;i386' \
		-D CMAKE_OSX_DEPLOYMENT_TARGET=10.7 \
		-D SHARED=off \
		-D WANT_ALLEGROGL=off -D WANT_LOADPNG=off -D WANT_LOGG=off -D WANT_JPGALLEG=off -D WANT_EXAMPLES=off -D WANT_TOOLS=off -D WANT_TESTS=off \
		-D WANT_DOCS=off \
		-D CMAKE_INSTALL_PREFIX=$(PREFIX) \
		-G Xcode .. && \
		xcodebuild -project ALLEGRO.xcodeproj -target ALL_BUILD -configuration Release && \
		xcodebuild -project ALLEGRO.xcodeproj -target install -configuration Release

define DUMB_CONF
include make/unix.inc
ALL_TARGETS := core core-headers
ALL_TARGETS += allegro allegro-headers
PREFIX := $(PREFIX)
PLAT_CFLAGS := -mmacosx-version-min=10.7 -arch i386 -arch x86_64 -I\$(PREFIX)/include
endef
export DUMB_CONF

dumb: prepare allegro
	tar xf $(LIBSRCDIR)/dumb-0.9.3.tar.gz -C $(BUILD)
	cd $(BUILD)/dumb-0.9.3 && \
		patch -p1 < $(PATCHESDIR)/dumb-0.9.3.patch && \
		echo "$$DUMB_CONF" > make/config.txt && \
		make veryclean && \
		make && \
		make install

=== Plugins/agspalrender/Makefile ===
INCDIR = ../../Engine ../../Common
CXX=g++
CXXFLAGS=-fPIC -fvisibility-inlines-hidden -Wall -std=gnu++11 $(addprefix -I,$(INCDIR))
DEPS=$(wildcard *.h)

all: libagspalrender.so

%.o: %.cpp $(DEPS)
	$(CXX) -c -o $@ $< $(CXXFLAGS)

libagspalrender.so: ags_palrender.o raycast.o
	$(CXX) -shared -o libagspalrender.so ags_palrender.o raycast.o $(CXXFLAGS)

clean:
	rm -f *.gch *.o *.so

.PHONY: clean

=== Common/libsrc/aastr-0.1.1/CMakeLists.txt ===
add_library(aastr)

set_target_properties(aastr PROPERTIES
    C_STANDARD 11
    C_EXTENSIONS NO
)

target_include_directories(aastr PUBLIC .)

target_sources(aastr 
    PRIVATE
    aarot.c
    aastr.c
    aastr.h
    aautil.c
    aautil.h
)

target_link_libraries(aastr PUBLIC Allegro::Allegro)

add_library(AAStr::AAStr ALIAS aastr)

=== Common/libsrc/alfont-2.0.9/CMakeLists.txt ===
add_library(alfont)

set_target_properties(alfont PROPERTIES
    C_STANDARD 11
    C_EXTENSIONS NO
)

target_include_directories(alfont PUBLIC . )

target_sources(alfont 
    PRIVATE
    alfont.h
    alfont.c
)

target_link_libraries(alfont PUBLIC Allegro::Allegro FreeType::FreeType)

add_library(AlFont::AlFont ALIAS alfont)

=== Common/libsrc/allegro4/CMakeLists.txt ===
#-----------------------------------------------------------------------------#
#
# CMake setup
#

cmake_minimum_required(VERSION 3.13..3.14)

#-----------------------------------------------------------------------------#
#
# Build options
#

# Set the project name.
project(allegro
    LANGUAGES C CXX
    VERSION 4.4.3
)

if(WIN32)
    enable_language(RC OPTIONAL)
endif(WIN32)

# Search in the `cmake' directory for additional CMake modules.
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")


#-----------------------------------------------------------------------------#
#
# Build options
#

option(MAGIC_MAIN "Enable magic main (Unix)" off)


#-----------------------------------------------------------------------------#
#
# Unix platform checks
#

include(CheckIncludeFiles)
include(CheckFunctionExists)
include(CheckCSourceCompiles)
include(CheckCSourceRuns)
include(FindPkgConfig)
include(TestBigEndian)

if(UNIX)
    test_big_endian(ALLEGRO_BIG_ENDIAN)
    if(NOT ALLEGRO_BIG_ENDIAN)
        set(ALLEGRO_LITTLE_ENDIAN 1)
    endif(NOT ALLEGRO_BIG_ENDIAN)

    check_include_files(dirent.h ALLEGRO_HAVE_DIRENT_H)
    check_include_files(inttypes.h ALLEGRO_HAVE_INTTYPES_H)

    check_include_files(linux/awe_voice.h ALLEGRO_HAVE_LINUX_AWE_VOICE_H)
    check_include_files(linux/input.h ALLEGRO_HAVE_LINUX_INPUT_H)
    # On some systems including linux/joystick.h without sys/types.h results
    # in conflicting definitions of fd_set.
    check_include_files("sys/types.h;linux/joystick.h" ALLEGRO_HAVE_LINUX_JOYSTICK_H)
    check_include_files(linux/soundcard.h ALLEGRO_HAVE_LINUX_SOUNDCARD_H)
    check_include_files(machine/soundcard.h ALLEGRO_HAVE_MACHINE_SOUNDCARD_H)
    check_include_files(soundcard.h ALLEGRO_HAVE_SOUNDCARD_H)
    check_include_files(stdint.h ALLEGRO_HAVE_STDINT_H)
    check_include_files(sys/io.h ALLEGRO_HAVE_SYS_IO_H)
    check_include_files(sys/stat.h ALLEGRO_HAVE_SYS_STAT_H)
    check_include_files(sys/time.h ALLEGRO_HAVE_SYS_TIME_H)
    check_include_files(sys/soundcard.h ALLEGRO_HAVE_SYS_SOUNDCARD_H)
    check_include_files(sys/utsname.h ALLEGRO_HAVE_SYS_UTSNAME_H)

    check_function_exists(getexecname ALLEGRO_HAVE_GETEXECNAME)
    check_function_exists(memcmp ALLEGRO_HAVE_MEMCMP)
    check_function_exists(mkstemp ALLEGRO_HAVE_MKSTEMP)
    check_function_exists(mmap ALLEGRO_HAVE_MMAP)
    check_function_exists(mprotect ALLEGRO_HAVE_MPROTECT)
    check_function_exists(sched_yield ALLEGRO_HAVE_SCHED_YIELD)
    check_function_exists(stricmp ALLEGRO_HAVE_STRICMP)
    check_function_exists(strlwr ALLEGRO_HAVE_STRLWR)
    check_function_exists(strupr ALLEGRO_HAVE_STRUPR)
    check_function_exists(sysconf ALLEGRO_HAVE_SYSCONF)

    check_c_source_compiles("
        #include <sys/procfs.h>
        #include <sys/ioctl.h>
        int main(void) {
            struct prpsinfo psinfo;
            ioctl(0, PIOCPSINFO, &psinfo);
            return 0;
        }"
        ALLEGRO_HAVE_SV_PROCFS_H
        )
    check_c_source_compiles("
        #include <sys/procfs.h>
        int main(void) {
            struct prpsinfo psinfo;
            psinfo.pr_argc = 0;
            return 0;
        }"
        ALLEGRO_HAVE_PROCFS_ARGCV
        )

    check_c_source_compiles("
        #include <unistd.h>
        #include <sys/mman.h>
        int main(void) {
            void *x = MAP_FAILED;
        }"
        MAP_FAILED_DEFINED)
    if(NOT MAP_FAILED_DEFINED)
        set(MAP_FAILED "((void *) -1)")
    endif()

    check_c_source_runs("
        static int notsupported = 1;
        void test_ctor (void) __attribute__((constructor));
        void test_ctor (void) { notsupported = 0; }
        int main(void) { return (notsupported); }
        "
        ALLEGRO_USE_CONSTRUCTOR)

    find_library(RT_LIBRARY rt)
    mark_as_advanced(RT_LIBRARY)
    check_c_source_compiles("
        #include <time.h>
        int main(void) {
            struct timespec new_time_ns;
            clock_gettime(CLOCK_MONOTONIC, &new_time_ns);
            return 0;
        }"
        ALLEGRO_HAVE_POSIX_MONOTONIC_CLOCK
        )

    if(MAGIC_MAIN)
        set(ALLEGRO_WITH_MAGIC_MAIN 1)
    endif(MAGIC_MAIN)

    # XXX const
    # XXX inline
    # XXX size_t
endif(UNIX)


#-----------------------------------------------------------------------------#
#
# Main library
#

add_library(allegro)

target_compile_definitions(allegro PRIVATE ALLEGRO_SRC)

target_compile_definitions (allegro
    INTERFACE 
        ALLEGRO_STATICLINK
        ALLEGRO_NO_COMPATIBILITY 
        ALLEGRO_NO_FIX_ALIASES 
        ALLEGRO_NO_FIX_CLASS
)

# ALLEGRO_SRC_FILES
target_sources(allegro PRIVATE
    src/allegro.c
    src/blit.c
    src/bmp.c
    src/clip3d.c
    src/clip3df.c
    src/colblend.c
    src/color.c
    src/config.c
    src/datafile.c
    src/dataregi.c
    src/digmid.c
    src/dither.c
    src/dispsw.c
    src/drvlist.c
    src/file.c
    src/fli.c
    src/flood.c
    src/font.c
    src/fontbios.c
    src/fontbmp.c
    src/fontdat.c
    src/fontgrx.c
    src/fonttxt.c
    src/fsel.c
    src/gfx.c
    src/glyph.c
    src/graphics.c
    src/gsprite.c
    src/gui.c
    src/guiproc.c
    src/inline.c
    src/joystick.c
    src/keyboard.c
    src/lbm.c
    src/libc.c
    src/lzss.c
    src/math.c
    src/math3d.c
    src/midi.c
    src/mixer.c
    src/modesel.c
    src/mouse.c
    src/pcx.c
    src/poly3d.c
    src/polygon.c
    src/quantize.c
    src/quat.c
    src/readbmp.c
    src/readfont.c
    src/readsmp.c
    src/rle.c
    src/rotate.c
    src/rsfb.c
    src/scene3d.c
    src/sound.c
    src/spline.c
    src/stream.c
    src/text.c
    src/tga.c
    src/timer.c
    src/unicode.c
    src/vtable.c
    src/vtable15.c
    src/vtable16.c
    src/vtable24.c
    src/vtable32.c
    src/vtable8.c
)

# ALLEGRO_SRC_C_FILES
target_sources(allegro PRIVATE
    src/c/cblit16.c
    src/c/cblit24.c
    src/c/cblit32.c
    src/c/cblit8.c
    src/c/ccpu.c
    src/c/ccsprite.c
    src/c/cgfx15.c
    src/c/cgfx16.c
    src/c/cgfx24.c
    src/c/cgfx32.c
    src/c/cgfx8.c
    src/c/cmisc.c
    src/c/cscan15.c
    src/c/cscan16.c
    src/c/cscan24.c
    src/c/cscan32.c
    src/c/cscan8.c
    src/c/cspr15.c
    src/c/cspr16.c
    src/c/cspr24.c
    src/c/cspr32.c
    src/c/cspr8.c
    src/c/cstretch.c
    src/c/czscan15.c
    src/c/czscan16.c
    src/c/czscan24.c
    src/c/czscan32.c
    src/c/czscan8.c
    src/misc/ccolconv.c
    src/misc/colconv.c
)

# set(ALLEGRO_INCLUDE_ALLEGRO_FILES
target_sources(allegro PRIVATE
    include/allegro/3d.h
    include/allegro/3dmaths.h
    include/allegro/alcompat.h
    include/allegro/alinline.h
    include/allegro/base.h
    include/allegro/color.h
    include/allegro/compiled.h
    include/allegro/config.h
    include/allegro/datafile.h
    include/allegro/debug.h
    include/allegro/digi.h
    include/allegro/draw.h
    include/allegro/file.h
    include/allegro/fix.h
    include/allegro/fixed.h
    include/allegro/fli.h
    include/allegro/fmaths.h
    include/allegro/font.h
    include/allegro/gfx.h
    include/allegro/graphics.h
    include/allegro/gui.h
    include/allegro/joystick.h
    include/allegro/keyboard.h
    include/allegro/lzss.h
    include/allegro/matrix.h
    include/allegro/midi.h
    include/allegro/mouse.h
    include/allegro/palette.h
    include/allegro/quat.h
    include/allegro/rle.h
    include/allegro/sound.h
    include/allegro/stream.h
    include/allegro/system.h
    include/allegro/text.h
    include/allegro/timer.h
    include/allegro/unicode.h
)

# set(ALLEGRO_INCLUDE_ALLEGRO_INLINE_FILES
target_sources(allegro PRIVATE
    include/allegro/inline/3dmaths.inl
    include/allegro/inline/asm.inl
    include/allegro/inline/color.inl
    include/allegro/inline/draw.inl
    include/allegro/inline/fix.inl
    include/allegro/inline/fmaths.inl
    include/allegro/inline/gfx.inl
    include/allegro/inline/matrix.inl
    include/allegro/inline/rle.inl
    include/allegro/inline/system.inl
)

# set(ALLEGRO_INCLUDE_ALLEGRO_INTERNAL_FILES
target_sources(allegro PRIVATE
    include/allegro/internal/aintern.h
    include/allegro/internal/aintvga.h
    include/allegro/internal/alconfig.h
)

# set(ALLEGRO_INCLUDE_ALLEGRO_PLATFORM_FILES
target_sources(allegro PRIVATE
    include/allegro/platform/aintbeos.h
    include/allegro/platform/aintdos.h
    include/allegro/platform/aintlnx.h
    include/allegro/platform/aintmac.h
    include/allegro/platform/aintosx.h
    include/allegro/platform/aintpsp.h
    include/allegro/platform/aintios.h
    include/allegro/platform/aintand.h
    include/allegro/platform/aintqnx.h
    include/allegro/platform/aintunix.h
    include/allegro/platform/aintwin.h
    include/allegro/platform/al386gcc.h
    include/allegro/platform/al386vc.h
    include/allegro/platform/al386wat.h
    include/allegro/platform/albcc32.h
    include/allegro/platform/albecfg.h
    include/allegro/platform/albeos.h
    include/allegro/platform/aldjgpp.h
    include/allegro/platform/aldmc.h
    include/allegro/platform/aldos.h
    include/allegro/platform/almac.h
    include/allegro/platform/almaccfg.h
    include/allegro/platform/almngw32.h
    include/allegro/platform/almsvc.h
    include/allegro/platform/alosx.h
    include/allegro/platform/alosxcfg.h
    # include/allegro/platform/alplatf.h.cmake
    include/allegro/platform/alpsp.h
    include/allegro/platform/alpspcfg.h
    include/allegro/platform/alios.h
    include/allegro/platform/alioscfg.h
    include/allegro/platform/aland.h
    include/allegro/platform/alandcfg.h
    include/allegro/platform/alqnx.h
    include/allegro/platform/alqnxcfg.h
    include/allegro/platform/alucfg.h
    include/allegro/platform/alunix.h
    # include/allegro/platform/alunixac.h.cmake
    # include/allegro/platform/alunixac.hin
    include/allegro/platform/alwatcom.h
    include/allegro/platform/alwin.h
    include/allegro/platform/astdint.h
    include/allegro/platform/macdef.h
)


#-----------------------------------------------------------------------------#
#
# Compiler and platform setup
#

if(CMAKE_COMPILER_IS_GNUCC)
    set(COMPILER_GCC 1)
    set(ALLEGRO_GCC 1)
endif(CMAKE_COMPILER_IS_GNUCC)

if(MSVC)
    set(COMPILER_MSVC 1)
    set(ALLEGRO_MSVC 1)
endif(MSVC)

if(WIN32)
    set(ALLEGRO_WINDOWS 1)
endif()

if(APPLE)
    set(ALLEGRO_MACOSX 1)
    set(ALLEGRO_DARWIN 1)
endif(APPLE)

if(UNIX AND NOT APPLE)
    set(ALLEGRO_UNIX 1)
endif()

if(IOS)
    set(ALLEGRO_IOS 1)

    set(ALLEGRO_IOS_ARCH arm64 CACHE STRING "iOS Architecture")
    set_property(CACHE ALLEGRO_IOS_ARCH PROPERTY STRINGS arm64 armv7 armv7s i386 x86_64)

    set(ALLEGRO_IOS_SDK iphoneos CACHE STRING "iOS SDK")
    set_property(CACHE ALLEGRO_IOS_SDK PROPERTY STRINGS iphoneos iphonesimulator)

    execute_process(COMMAND xcrun --sdk ${ALLEGRO_IOS_SDK} --show-sdk-path
        OUTPUT_VARIABLE SDK_PATH
        OUTPUT_STRIP_TRAILING_WHITESPACE)
    set(IOS_ADDITIONAL_LIBRARY_PATH "$(pwd)/../../../nativelibs/${ALLEGRO_IOS_ARCH}")
    set(IOS_PLATFORM_INCLUDE "${SDK_PATH}/usr/include")
    set(IOS_PLATFORM_LIB "${SDK_PATH}/usr/lib")

    target_compile_options(allegro PRIVATE -arch ${ALLEGRO_IOS_ARCH})
endif(IOS)

if(ANDROID)
    set(ALLEGRO_ANDROID 1)
endif(ANDROID)

target_compile_definitions(allegro PUBLIC ALLEGRO_STATICLINK)
target_compile_definitions(allegro PUBLIC $<$<CONFIG:DEBUG>:DEBUGMODE=1>)


#-----------------------------------------------------------------------------#

# Not sure if we want to support disabling these any more.
set(ALLEGRO_COLOR8 1)
set(ALLEGRO_COLOR16 1)
set(ALLEGRO_COLOR24 1)
set(ALLEGRO_COLOR32 1)

set(ALLEGRO_NO_ASM 1)
# ALLEGRO_MMX left undefined
# ALLEGRO_SSE left undefined


#-----------------------------------------------------------------------------#
#
# Platform drivers
#

# -- Unix --

option(WANT_OSS "Build OSS support" off)
option(WANT_ALSA "Build ALSA support" on)
option(WANT_JACK "Build JACK support" on)

if(ALLEGRO_UNIX) # not MACOSX
    target_sources(allegro PRIVATE
        src/unix/alsa9.c
        src/unix/alsamidi.c

=== Common/libsrc/freetype-2.1.3/CMakeLists.txt ===
add_library(freetype)

set_target_properties(freetype PROPERTIES
    C_STANDARD 11
    C_EXTENSIONS NO
)

target_include_directories(freetype PUBLIC include )

target_sources(freetype 
    PRIVATE
    src/base/ftbase.c
    src/base/ftglyph.c
    src/base/ftinit.c
    src/base/ftmm.c

    src/autohint/autohint.c
    src/bdf/bdf.c
    src/cache/ftcache.c
    src/cff/cff.c
    src/cid/type1cid.c
    src/gzip/ftgzip.c
    src/pcf/pcf.c
    src/pfr/pfr.c
    src/psaux/psaux.c
    src/pshinter/pshinter.c
    src/psnames/psmodule.c
    src/raster/raster.c
    src/sfnt/sfnt.c
    src/smooth/smooth.c
    src/truetype/truetype.c
    src/type1/type1.c
    src/type42/type42.c
    src/winfonts/winfnt.c

    # the following files may be unix only:
    src/base/ftbbox.c
    src/base/ftbdf.c
    src/base/ftpfr.c
    src/base/fttype1.c
    src/base/ftxf86.c
)

if (WIN32)
    target_sources(freetype PRIVATE 
        src/base/ftsystem.c 
        builds/win32/ftdebug.c
    )
elseif (MACOS OR LINUX)
    target_sources(freetype PRIVATE 
        builds/unix/ftsystem.c 
        src/base/ftdebug.c
    )
endif()

#target_link_libraries(freetype PUBLIC ZLIB::ZLIB BZip2::BZip2)

add_library(FreeType::FreeType ALIAS freetype)

=== Engine/libsrc/almp3-2.0.5/CMakeLists.txt ===
add_library(almp3)

set_target_properties(almp3 PROPERTIES
    C_STANDARD 11
    C_EXTENSIONS NO
)

target_include_directories(almp3 
    PUBLIC  include
    PRIVATE .           # for ./decoder
)

target_sources(almp3 
    PRIVATE
    src/almp3.c
    decoder/common.c
    decoder/dct64_i386.c
    decoder/decode_i386.c
    decoder/huffman.h
    decoder/interface.c
    decoder/l2tables.h
    decoder/layer2.c
    decoder/layer3.c
    decoder/mpg123.h
    decoder/mpglib.h
    decoder/tabinit.c
)

target_link_libraries(almp3 PUBLIC Allegro::Allegro)

# The PSP (and embedded processors in general) only has hardware support for single precision math.
if (ANDROID OR IOS)
    target_compile_definitions(almp3 PRIVATE REAL_IS_FLOAT)
endif()

add_library(AlMp3::AlMp3 ALIAS almp3)

=== debian/changelog ===
ags (3~git) UNRELEASED; urgency=low

  * some release

 -- Tobias Hansen <tobias.han@gmx.de>  Mon, 18 Feb 2013 22:13:14 +0100

=== debian/control ===
Source: ags
Section: games
Priority: optional
Maintainer: Tobias Hansen <tobias.han@gmx.de>
Build-Depends: debhelper (>= 8.0.0),
               pkg-config,
               liballegro4-dev,
               libaldmb1-dev,
               libfreetype6-dev,
               libtheora-dev,
               libvorbis-dev,
               libogg-dev
Standards-Version: 3.9.3
Homepage: https://github.com/adventuregamestudio/ags
Vcs-Git: git://github.com/adventuregamestudio/ags.git
Vcs-Browser: https://github.com/adventuregamestudio/ags

Package: ags
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Adventure Game Studio runtime engine
 AGS is an adventure game engine with many games available.
 .
 Package built on ${buildinfo:Date}
 using git ${buildinfo:Git-Object}.

Package: ags-dbg
Architecture: any
Section: debug
Priority: extra
Depends:
    ags (= ${binary:Version}),
    ${misc:Depends}
Description: Adventure Game Studio runtime engine (debugging symbols)
 AGS is an adventure game engine with many games available.
 .
 This package contains the debugging symbols for ags.
 .
 Package built on ${buildinfo:Date}
 using git ${buildinfo:Git-Object}.

=== debian/rules ===
#!/usr/bin/make -f

# Keep this list of folders that are not included in the
# orig syncronized with the one in debian/source/local-options!
ORIG_CONTENT := $(shell git ls-tree --name-only HEAD | grep -Ev '^(Android|Editor|iOS|OSX|PSP|Windows|debian|\.git.*)')
VERSION := $(shell head -1 debian/changelog | sed 's/.*(\(.*\)).*/\1/')
MAKE = make --directory=Engine
GENCONTROL_SUBSTVARS = -Vbuildinfo:Date="$(shell date -R)" -Vbuildinfo:Git-Object="$(shell git show HEAD | head -n1)"

ifneq (,$(filter rpath=%,$(DEB_BUILD_OPTIONS)))
  RPATH = $(patsubst rpath=%,%,$(filter rpath=%,$(DEB_BUILD_OPTIONS)))
  export RPATH
endif

%:
	dh $@ --parallel --buildsystem makefile

override_dh_auto_clean:
	$(MAKE) clean

override_dh_auto_build:
	$(MAKE)

override_dh_auto_install:
	$(MAKE) install PREFIX=$(CURDIR)/debian/tmp/usr

override_dh_clean:
	dh_clean --exclude=Editor/*

get-orig-source:
	mkdir -p ../orig_temp/ags_$(VERSION)
	debian/git-archive-all.sh ../orig_temp/ags_$(VERSION)/orig_temp.tar
	cd ../orig_temp/ags_$(VERSION) && tar -xf orig_temp.tar $(ORIG_CONTENT)
	rm ../orig_temp/ags_$(VERSION)/orig_temp.tar
	cd ../orig_temp && tar -pczf ../ags_$(VERSION).orig.tar.gz ags_$(VERSION)
	rm -rf ../orig_temp

override_dh_gencontrol:
	dh_gencontrol -- $(GENCONTROL_SUBSTVARS)

.PHONY: override_dh_strip
override_dh_strip:
	dh_strip --dbg-package=ags-dbg
